import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;

public class MultiServerThread extends Thread {

	Socket socket = null;
	String filename;

	public MultiServerThread(Socket connection, String filename) {
		this.socket = connection;
		this.filename = filename;
	}

	public void run() {

		try {

			PrintWriter out = new PrintWriter(socket.getOutputStream(), true);
			BufferedReader in = new BufferedReader(new InputStreamReader(socket
					.getInputStream()));
			String inputLine, outputLine;

			RadioMapProtocol rmp = new RadioMapProtocol(filename);

			outputLine = rmp.processInput(null);
			/* Sending "+OK READY" */
			
			System.out.println("Send: " + outputLine);
			out.println(outputLine);
			
			while ((inputLine = in.readLine()) != null) {
				System.out.println("Receive: " + inputLine);
				outputLine = rmp.processInput(inputLine);
				out.println(outputLine);
				System.out.println("Send: " + outputLine);
				if (outputLine.startsWith("RADIOMAP"))
					break;
			}

			if (outputLine.startsWith("UNAVAILABLE") || outputLine == null){
				System.out.println("Closed");
			    out.close();
			    in.close();
			    socket.close();
			    return;
			}
			
			do{
				outputLine = rmp.processInput(inputLine);
				out.println(outputLine);
				System.out.println("Send: " + outputLine);
			}while(outputLine != null && !outputLine.startsWith("CORRUPTED"));
			
			System.out.println("Closed");
		    out.close();
		    in.close();
		    socket.close();
		    
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
